<?php
/*
Plugin Name: wpPopupWizard
Plugin URI: 
Description: Sophisticated Popup Manager
Author: Ken Sar
Version: 1.00.00
Author URI: http://www.wpPopupWizard.com
Info Location: http://www.wpPopupWizard.com
*/   
   
/*  Copyright 2011 wpPopupWizard.com
*/

/**
* Guess the wp-content and plugin urls/paths
*/
// Pre-2.6 compatibility
if ( ! defined( 'WP_CONTENT_URL' ) )
      define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
      define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
      define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
      define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );
define('KSWPPW_PLUGIN_URL', WP_PLUGIN_URL . '/kswp_pop_wizard/');
define('KSWPPW_PLUGIN_DIR', WP_PLUGIN_DIR . '/kswp_pop_wizard/');
define('KSWPPW_TEMPLATE_URL', KSWPPW_PLUGIN_URL . 'templates/');
define('KSWPPW_TEMPLATE_DIR', KSWPPW_PLUGIN_DIR . 'templates/');
define('KSWPPW_SQZ_TEMPLATE_URL', KSWPPW_PLUGIN_URL . 'squeeze_templates/');
define('KSWPPW_SQZ_TEMPLATE_DIR', KSWPPW_PLUGIN_DIR . 'squeeze_templates/');

define('KSWPPW_SYS_VERSION', '1.00.00');

define('KSWPPW_OPTION_PAGE_TITLE', 'wpPopWizard for WordPress');
define('KSWPPW_MENU_TITLE', 'wpPopWizard');
define('KSWPPW_COMPANY_NAME', 'wpPopWizard.com');
define('KSWPPW_FOOTER_HREF', 'http://www.wpPopWizard.com');
define('KSWPPW_FOOTER_ANCHORTEXT', 'wpPopWizard.com');

global $kswp_pop_wizard_var;

function kswp_pop_wizard_activate() {
    global $wpdb;

    $kswp_pop_wizard_items = $wpdb->prefix . 'kswp_pop_wizard_items' ; 
    // if($wpdb->get_var("show tables like '$kswp_pop_wizard_items'") != $kswp_pop_wizard_items) {
      
        $qry = "CREATE TABLE $kswp_pop_wizard_items (
                  `id` int(11) NOT NULL auto_increment,
                  `item_id` varchar(30) NOT NULL default '',
                  `item_name` varchar(80) NOT NULL,
                  `main_body` text NOT NULL default '',
                  `template` varchar(10) NOT NULL default '',
                  `display_mode` varchar(10) NOT NULL default '',
                  `enable_popup` tinyint NOT NULL default 0,
                  `use_start_date` char(4) NOT NULL default '',
                  `start_date` datetime NULL,
                  `use_end_date` char(4) NOT NULL default '',
                  `end_date` datetime NULL,
                  `popup_displays_on` varchar(10) NOT NULL default '',
                  `display_page` varchar(10) NOT NULL default '',
                  `popup_type` varchar(10) NOT NULL default '',
                  `slide_from` varchar(10) NOT NULL default '',
                  `slide_to` varchar(10) NOT NULL default '',
                  `show_on_exit` varchar(8) NOT NULL default '',
                  `tooltip_sticky` varchar(8) NOT NULL default '',
                  `tooltip_track` varchar(8) NOT NULL default '',
                  `tooltip_shadow` varchar(8) NOT NULL default '',
                  `tooltip_activation` varchar(8) NOT NULL default '',
                  `top_padding` varchar(6) NOT NULL default '',
                  `popup_width` varchar(6) NOT NULL default '',
                  `popup_height` varchar(6) NOT NULL default '',
                  `popup_padding` varchar(6) NOT NULL default '',
                  `popup_margin_top` varchar(6) NOT NULL default '',
                  `background_color` varchar(8) NOT NULL default '',
                  `background_trans` char(4) NOT NULL default '',
                  `border_color` varchar(8) NOT NULL default '',
                  `border_width` varchar(6) NOT NULL default '',
                  `border_radius` varchar(6) NOT NULL default '',
                  `delay_secs` int NOT NULL default 0,
                  `action_secs` decimal(6,3) NOT NULL default 0,
                  `delay_days` decimal(6,3) NOT NULL default 0,
                  PRIMARY KEY  (id),
                  UNIQUE KEY `idx_{$kswp_pop_wizard_items}_item_id_unique` (`item_id`)
                );";

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($qry);
    // }
    
}
register_activation_hook(__FILE__, 'kswp_pop_wizard_activate');       

require_once( dirname(__FILE__) . '/kswp_pop_wizard_editorbutton.php');
require_once dirname(__FILE__) . '/kswp_pop_wizard-inc.php';

global $kswp_pop_wizard_var;
//instantiate the class
if (class_exists('kswp_pop_wizard')) {
    $kswp_pop_wizard_var = new kswp_pop_wizard();
}
?>