<?php

/**
 * @title TinyMCE V3 Button Integration (for Wp2.5)
 * @author Alex Rabe
 */

class add_kswppwEditorButton_button {
	
	var $pluginname = "kswppwEditorButton";
	
	function add_kswppwEditorButton_button()  {
		// Modify the version when tinyMCE plugins are changed.
		add_filter('tiny_mce_version', array (&$this, 'change_tinymce_version') );
		
		// init process for button control
		add_action('init', array (&$this, 'addbuttons') );
		add_action('admin_print_scripts',array(&$this,'admin_javascript'));
		add_action('admin_footer',array(&$this,'admin_footer'));
	}

	function addbuttons() {
	
		// Don't bother doing this stuff if the current user lacks permissions
		if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) return;
		
	    //rich_editing
        add_filter("mce_external_plugins", array (&$this, "add_tinymce_plugin" ), 5);
        add_filter('mce_buttons', array (&$this, 'register_button' ), 5);

	    //for html editing 
	    add_action('edit_form_advanced', array(&$this,'print_javascript'));
		add_action('edit_page_form',array(&$this,'print_javascript'));
	}
	
	// used to insert button in wordpress 2.5x editor
	function register_button($buttons) {
	
		array_push($buttons, "separator", $this->pluginname );
	
		return $buttons;
	}
	
	// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
	function add_tinymce_plugin($plugin_array) {    
	
		$plugin_array[$this->pluginname] =  kswppwEditorButton_URLPATH.'tinymce/editor_plugin.js';
		
		return $plugin_array;
	}
	
	function change_tinymce_version($version) {
		return ++$version;
	}
    
	function admin_javascript(){
		//show only when editing a post or page.
		if (strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'post-new.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php') || strpos($_SERVER['REQUEST_URI'], 'page.php')) {
		
			//wp_enqueue_script only works  in => 'init'(for all), 'template_redirect'(for only public) , 'admin_print_scripts' for admin only
			if (function_exists('wp_enqueue_script')) {
				wp_enqueue_script('jqmodal_kswppw', kswppwEditorButton_URLPATH .'js/jqModal/jqModal.js', array('jquery'));
			}
		}
	}

	function print_javascript () {
	 
    ?>
    <!--  for popup dialog -->
    <link href="<?php echo kswppwEditorButton_URLPATH . 'js/jqModal/jqModal.css'; ?>" type="text/css" rel="stylesheet" />

    <script type="text/javascript">
   	jQuery(document).ready(function(){
		// Add the buttons to the HTML view
		jQuery("#ed_toolbar").append('<input type=\"button\" class=\"ed_button\" onclick=\"jQuery(\'#dialog_kswppwtt\').jqmShow();\" title=\"wpPopWizard Tooltip\" value=\"wpPopWizard\" />');
   	});

	jQuery(document).ready(function () {
		jQuery('#dialog_kswppwtt').jqm({onShow:parse_selection});
	});

    var parse_selection = function(hash) {
		var f=document.kswppw_item;
        var patt0 = /\[wpPopWizard\s*(.*)\].*\[\/wpPopWizard\]/gi;
        var patt1 = /(item_id|inltext|newwindow|clickthru)\s*=\s*(\',*\'|".*"|\S*)/gi;
        var the_selection;
        var parsed1;
        
		if ( typeof tinyMCE != 'undefined' && ( ed = tinyMCE.activeEditor ) && !ed.isHidden() ) {
            the_selection = ed.selection.getContent();
		} else {
            the_selection = edCanvas.value.substring(edCanvas.selectionStart, edCanvas.selectionEnd);
        }
        
        the_selection = String(the_selection).replace(/\t/g, "").replace(/\r/g, "").replace(/\n/g, "");
        f.item_id.value = "";
        f.tooltip_clickdest.value = "";
        f.tooltip_clickthru.checked = false;
        f.tooltip_newwindow.checked = false;
        f.inlinetip_body.value = "";
        document.getElementById("inlinetip_body_area").value = CKEDITOR.instances.inlinetip_body_area.setData("");
        document.getElementById('inlinetip_text').style.display = 'none';
        
        if(the_selection.length > 0) {
            parsed1 = the_selection.match(patt0);
            if(!(parsed1 == null || parsed1 == "")) {
                var str = RegExp.$1;
                matches = str.match(patt1);

                for(i=0;i<matches.length; i++) {
                    attmatches = matches[i].match(patt1);
                    switch(RegExp.$1) {
                        case 'item_id':
                            f.item_id.value = RegExp.$2;
                            break;
                        case 'clickthru':
                            f.tooltip_clickthru.checked = true;
                            f.tooltip_clickdest.value = RegExp.$2;
                            break;
                        case 'newwindow':
                            f.tooltip_newwindow.checked = (RegExp.$2 == 'yes');
                            break;
                        case 'inltext':
                            inline_text = String(RegExp.$2).replace(/^"/g, '').replace(/"$/g, '').replace(/\{-dqt-\}/g, '"').replace(/\{-sqt-\}/g, '"').replace(/&amp;/g, '&').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&quot;/g, '"');
                            f.inlinetip_body.value = inline_text;
                            document.getElementById("inlinetip_body_area").value = CKEDITOR.instances.inlinetip_body_area.setData(inline_text);
                            document.getElementById('inlinetip_text').style.display = 'block';
                            break;
                    }
                }
            }
        }
        
        // alert("I'm here. \n\n" + the_selection);
        hash.w.show();
    };
	function update_kswppw_editor() {
		var tagtext, the_selection, playdough;
		var f=document.kswppw_item;
		if (f== null) return;
        if(f.item_id.value == '') return;
        
        popup_parms = 'item_id='+f.item_id.value;
        if(f.tooltip_clickthru.checked && !(f.tooltip_clickdest.value == "")) {
            popup_parms += ' clickthru='+f.tooltip_clickdest.value;
            if(f.tooltip_newwindow.checked) popup_parms += ' newwindow=yes';
        }
        
        document.getElementById("inlinetip_body_area").value = CKEDITOR.instances.inlinetip_body_area.getData();
        if(f.item_id.value == 'kswppw_in1ine' && f.inlinetip_body.value.length > 0 && f.inlinetip_body.value.length < 400) {
            popup_parms += ' inltext="' + String(f.inlinetip_body.value).replace(/\t/g, "").replace(/\r/g, "").replace(/\n/g, "").replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '{-dqt-}').replace(/'/g, '{-sqt-}') + '" ';
		}
        
		tagtext='[wpPopWizard ' + popup_parms + ' ]';
        
		if ( typeof tinyMCE != 'undefined' && ( ed = tinyMCE.activeEditor ) && !ed.isHidden() ) {
		// if(window.tinyMCE && (ed = window.tinyMCE.get('content'))) {
            the_selection = ed.selection.getContent();
                       
            tagtext += the_selection.replace(/\t/g, "").replace(/\r/g, "").replace(/\n/g, "").replace(/\[wpPopWizard.*?\]/i, '').replace(/\[\/wpPopWizard\]/i, '') + '[/wpPopWizard]';
            
            ed.focus();
            if (tinyMCE.isIE)  ed.selection.moveToBookmark(tinymce.EditorManager.get('content').windowManager.bookmark);

			window.tinyMCE.execInstanceCommand('content', 'mceInsertContent', false, tagtext);
			//Peforms a clean up of the current editor HTML. 
			//tinyMCEPopup.editor.execCommand('mceCleanup');
			//Repaints the editor. Sometimes the browser has graphic glitches. 
			// tinyMCEPopup.editor.execCommand('mceRepaint');
			// tinyMCEPopup.close();
		} else {
            the_selection = edCanvas.value.substring(edCanvas.selectionStart, edCanvas.selectionEnd);
            tagtext += the_selection.replace(/\t/g, "").replace(/\r/g, "").replace(/\n/g, "").replace(/\[wpPopWizard.*?\]/i, '').replace(/\[\/wpPopWizard\]/i, '') + '[/wpPopWizard]';
            
            edInsertContent(edCanvas, tagtext);
        }
		 
		jQuery('#dialog_kswppwtt').jqmHide();
	}

    function show_hide_inline_text($value) {
        var inline_div = document.getElementById('inlinetip_text');

        if($value == 'kswppw_in1ine') {
            $type = 'block';
        } else {
            $type = 'none';
        }
        inline_div.style.display = $type;
    } 

    </script>

	<?php   
	  //end of print_javascript 
	}

	function admin_footer(){
        global $wpdb;
		
        $popup_item_opts = '<option value="" >Select popup item...&nbsp;&nbsp;</option><option value="kswppw_in1ine"  >* Inline *</option>';
        $popup_items = $wpdb->get_results("SELECT item_id, item_name FROM {$wpdb->prefix}kswp_pop_wizard_items where popup_type IN ('tooltip', 'quicktip') ");
        if($popup_items) {
            foreach($popup_items as $popup_item) {
                $popup_item_opts .= '<option value="'. $popup_item->item_id . '"' . ($popup_item->item_id == $in_item_id ? ' selected' : '') . ' >' . $popup_item->item_name . '</option>';
            }
		}
		?>
		<div id="dialog_kswppwtt" class='jqmWindow' style='display:none'>
        <div style='width:100%;text-align:center'>
        <h3>wpPopWizard Tooltip Item</h3>
         
        <form name='kswppw_item' onsubmit='return false;' >
        <table border="0" cellspacing="0" style='text-align:left;width:100%;'>
            <tr> 
                <td valign='top' align="right" nowrap style="text-align: right;">Popup Item:&nbsp;</td>
                <td>
                    <select name="item_id" id="item_id" onchange="javascript: show_hide_inline_text(this.options[this.selectedIndex].value);">
                    <?php echo $popup_item_opts; ?>
                    </select>
                </td>
            </tr>
            <tr style="background-color: #eeeeee;"> 
                <td valign='top' align="right" nowrap style="text-align: right; padding: 3px 0;">Click Thru:&nbsp;<br />Destination:&nbsp;</td>
                <td style="padding: 3px 0;">
                    <input type="checkbox" name="tooltip_clickthru" value="yes">&nbsp;Yes&nbsp;&nbsp;
                    <input type="checkbox" name="tooltip_newwindow" value="yes">&nbsp;Open in New Window/Tab<br />
                    <input type="text" name="tooltip_clickdest" value="" size="50">
                </td>
            </tr>
            <tr><td></td>
                <td valign='top' colspan="2" align="right" style="text-align: right;">
                    <div id="inlinetip_text" name="inlinetip_text" style="margin-top: 10px; display: none;">
                        <textarea name="inlinetip_body" id="inlinetip_body_area" cols="40" rows="3" style="margin: 0 auto;"></textarea>
                        <script type="text/javascript">
                            CKEDITOR.replace( 'inlinetip_body_area',
                                    {
                                        toolbar : 
                                            [
                                                { name: 'clipboard', items : [ 'Cut','Copy','Paste','-','Undo','Redo' ] },
                                                { name: 'basicstyles', items : [ 'Bold','Italic','Underscore','-','RemoveFormat' ] },
                                                { name: 'paragraph', items : [ 'NumberedList','BulletedList' ] },
                                                { name: 'tools', items : [ 'About' ] }
                                            ],
                                        height : 100,
                                        width  : '95%',
                                        resize_enabled : false
                                    });
                        </script>
                    </div>
                </td>
            </tr>
        </table>
        <div class="mceActionPanel" style="margin-top: 20px; width: 60%; margin-left: auto; margin-right: auto;">
            <div style="float: left">
                <input type="button" id="cancel" name="cancel" value="<?php _e("Cancel", 'epp_parms'); ?>" onclick="jQuery('#dialog_kswppwtt').jqmHide();" style="width: 100px;" />
            </div>

            <div style="float: right">
                <input type="button" id="insert" name="insert" value="<?php _e("Insert", 'epp_parms'); ?>" onclick="update_kswppw_editor();" style="width: 100px;" />
            </div>
        </div>
        </form>	 
        </div>	
        </div>
        <?php 
		
	}
    
}

// Call it now
$tinymce_button2 = new add_kswppwEditorButton_button ();

?>